/*
	Publimark
 
	Copyright (c) 2004, Gatan Le Guelvouit <leguelvouit@lss.supelec.fr>
 
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
 
	This program is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied
	warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
	PURPOSE.  See the GNU General Public License for more details.
 
	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the Free
	Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
	MA 02111-1307, USA.
*/

#ifndef _CRYPTO_H_
#define _CRYPTO_H_

#include <string>
#include <fstream>
#include <iostream>
#include <botan/rsa.h>
#include <botan/lookup.h>
#include <botan/filters.h>
#include <botan/look_pk.h>
#include <botan/x509self.h>

#include "common.h"

using namespace std;

class crypto
{
public:
	//! Compute a pair of cryptographic keys.
	static void get_pair(string& pub, string& prv);
	
	//! Encrypt a message with the public key.
	static string encrypt(const string& m, const char*);
	
	//! Decrypt a message using the private key.
	static string decrypt(const string& m, const char*);
};

#endif

