/*
	Publimark
 
	Copyright (c) 2004, Gatan Le Guelvouit <leguelvouit@lss.supelec.fr>
 
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
 
	This program is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied
	warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
	PURPOSE.  See the GNU General Public License for more details.
 
	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the Free
	Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
	MA 02111-1307, USA.
*/

#ifndef _INITTCQ_H_
#define _INITTCQ_H_

#include "tcq.h"
#include "seed.h"
#include "crypto.h"
#include "common.h"

//! Transmission of the temp. private seed.
class init
{
private:
	double delta;
	
	vector<double> D(const vector<double>& u, const vector<double>& b);
	
public:
	init(double sw2) : delta(sqrt(12*sw2)) {LOG("--  [init::init] Delta = " << delta << endl;);};
	
	seed embed(vector<double>& x, const char* pub);
	
	seed extract(vector<double>& x, const char* prv);
	
	double get_delta() {return delta;};
};

#endif

