/*
	Publimark
 
	Copyright (c) 2004, Gatan Le Guelvouit <leguelvouit@lss.supelec.fr>
 
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
 
	This program is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied
	warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
	PURPOSE.  See the GNU General Public License for more details.
 
	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the Free
	Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
	MA 02111-1307, USA.
*/

#ifndef _SCS_H_
#define _SCS_H_

#include <vector> 

#include "seed.h"

using namespace std;

//! The scalar Costa scheme (see Eggers' work).
class scs
{
private:
	double delta;
	seed	 scs_seed;
	
public:
		scs(const seed& my_seed, const double my_delta) : delta(my_delta*2), scs_seed(my_seed) {};
	
		void embed(vector<double>& x, const char c, const bool reset = false);
		void embed(vector<double>& x, const string& s, const bool reset = false);
		
		char   extractc(const vector<double>& x, const bool reset = false);
		string extracts(const vector<double>& x, const bool reset = false);
};

#endif

