/*
	Publimark
 
	Copyright (c) 2004, Gatan Le Guelvouit <leguelvouit@lss.supelec.fr>
 
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
 
	This program is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied
	warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
	PURPOSE.  See the GNU General Public License for more details.
 
	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the Free
	Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
	MA 02111-1307, USA.
*/

#include "seed.h"

long int seed::super_seed = time(&super_seed);


seed::seed() 
{
	srandom(super_seed++);
	
	for(uint i=0; i<8*sizeof(unsigned long); i++) S+=((unsigned long)(random()%2))<<i;
	
	init();
}

seed::seed(const string& v)
{
	S=0;
	
	for(uint i=0; i<sizeof(unsigned long); i++) S+=(unsigned long)(int(v[i]+128))<<(8*i*sizeof(char));
}

double seed::get_random()
{
	return (double(random())/(double)RAND_MAX);
}

seed::operator const string()
{
	string ret;

	for(uint i=0; i<sizeof(unsigned long); i++)
	{
		char c = (S>>(i*8*sizeof(char)))%(1<<(8*sizeof(char))) - 128;
		ret+=c;
	}
	
	return ret;

}

ostream& operator<<(ostream& os, const seed& s)
{
	os << s.S;
	
  return os;
}



