/*
	Publimark
 
	Copyright (c) 2004, Gatan Le Guelvouit <leguelvouit@lss.supelec.fr>
 
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
 
	This program is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied
	warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
	PURPOSE.  See the GNU General Public License for more details.
 
	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the Free
	Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
	MA 02111-1307, USA.
*/

#ifndef _SEED_H_
#define _SEED_H_

#include <string>
#include <time.h>
#include <iostream>
#include <stdlib.h>

#include "common.h"

using namespace std;

//! Random seed for random generators 
class seed
{
private:
	char					state[256];
	static time_t super_seed;
	unsigned long S;
	
public:
	seed();

	seed(const string& v);
	
	unsigned int size() {return sizeof(unsigned long);};
	
	//! Initialize the associated pseudo-random generator.
	void init() {initstate(S, state, 256);};
	
	//! Return a pseudo-random value between 0 and 1.
	double get_random();
	
	unsigned long get_value() {return S;};
	
	operator const string();
	
	friend ostream& operator<<(ostream& os, const seed& s);
};

#endif

