/*
	Publimark
 
	Copyright (c) 2004, Gatan Le Guelvouit <leguelvouit@lss.supelec.fr>
 
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
 
	This program is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied
	warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
	PURPOSE.  See the GNU General Public License for more details.
 
	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the Free
	Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
	MA 02111-1307, USA.
 */

int send(const char* input, const char* output, const char* key, const double power)
{
	// Opening input cover file and getting infos
	AFfilehandle infile       = afOpenFile(input, "r", NULL); 
	AFfilesetup  outfilesetup = afNewFileSetup();

	if(infile ==NULL) ERR("Cannot open audio file " << input);
		
	int    af_format, af_width;
	double err = 0; 
	double nbs = 0;
	seed   Stmp;
	
	afGetSampleFormat(infile, AF_DEFAULT_TRACK, &af_format, &af_width);

	int    af_channel		= afGetChannels(infile, AF_DEFAULT_TRACK);
	int    af_frame     = afGetFrameCount(infile, AF_DEFAULT_TRACK); 
	double af_rate      = afGetRate(infile, AF_DEFAULT_TRACK);
	
	// Intializing output data format 
	if(strstr(output, ".wav")==NULL)
	{
		LOG("--[main::send] Writing AIFF file\n");
		afInitFileFormat(outfilesetup, AF_FILE_AIFF);
		afInitByteOrder(outfilesetup, AF_DEFAULT_TRACK, AF_BYTEORDER_BIGENDIAN);
	} 
	else 
	{
		LOG("--[main::send] Writing WAVE file\n");
		afInitFileFormat(outfilesetup, AF_FILE_WAVE); 
		afInitByteOrder(outfilesetup, AF_DEFAULT_TRACK, AF_BYTEORDER_LITTLEENDIAN);
	}
	
	afInitChannels(outfilesetup, AF_DEFAULT_TRACK, af_channel);
	afInitRate(outfilesetup, AF_DEFAULT_TRACK, af_rate);
	afInitSampleFormat(outfilesetup, AF_DEFAULT_TRACK, af_format, af_width);

	// Opening output audio file 
	AFfilehandle outfile = afOpenFile(output, "w", outfilesetup);		

	if(outfile==NULL) ERR("Cannot write audio file " << output);
	/*
	{ // Initialization 
		int    nb_data  = CRYPTO_RATE*SEED_BITS+2*REGISTER-2;
		int    nb_frame = (INIT_GAP*(CRYPTO_RATE*SEED_BITS+2*REGISTER-2)+1)/af_channel;
		short* buffer   = new short[af_channel*nb_frame];
		
		vector<double> data(nb_data);
		
		// Reading host data from file 
		afReadFrames(infile, AF_DEFAULT_TRACK, (void*)buffer, nb_frame);
		for(uint i=0; i<data.size(); i++) data[i]=double(buffer[INIT_GAP*i]);
		
		init my_init(pow(10.0, power/10));
		
		Stmp=my_init.embed(data, key);

		// Quantization
		for(uint i=0; i<data.size(); i++)
		{
			if(data[i]>0) data[i]=short(data[i]+0.5); else data[i]=short(data[i]-0.5);
			err+=CARRE(data[i]-buffer[i*INIT_GAP]); nbs++;
			
			buffer[INIT_GAP*i]=short(data[i]);
		} 
		
		afWriteFrames(outfile, AF_DEFAULT_TRACK, (void*)buffer, nb_frame); 
		af_frame-=nb_frame; 
		
		LOG("--[main::send] Initialisation phase OK.\n");
	}	

	{ // Permanent phase
		int    c;
		
		Stmp.init();
		
		do
		{
			c=cin.get(); 
			
			if(af_frame*af_channel<PERM_GAP*8*sizeof(char)) ERR("Not enough host data in " << input << ": choose a longer host file");
			
			int    nb_data  = 8*sizeof(char);
			int    nb_frame = PERM_GAP*nb_data/af_channel;
			short* buffer   = new short[af_channel*nb_frame];
			
			vector<double> data(nb_data);
			
			// Reading host data
			afReadFrames(infile, AF_DEFAULT_TRACK, (void*)buffer, nb_frame);
			for(uint i=0; i<data.size(); i++) 
			{
				data[i]=double(buffer[PERM_GAP*i]);
			} 
			
			scs my_scs(Stmp, pow(10.0, power/10));
			
			my_scs.embed(data, c, false);
			
			// Quantization
			for(uint i=0; i<data.size(); i++)
			{
				if(data[i]>0) data[i]=short(data[i]+0.5); else data[i]=short(data[i]-0.5);
				err+=CARRE(data[i]-buffer[PERM_GAP*i]); nbs++;
				
				buffer[PERM_GAP*i]=short(data[i]);
			} 
			
			afWriteFrames(outfile, AF_DEFAULT_TRACK, (void*)buffer, nb_frame); 
			af_frame-=nb_frame;
						
		} while(c!=EOF);
		
		LOG("--[main::send] Permanent phase OK.\n");
		LOG("--[main::send] Disto : " << 10.0*log(err/nbs)/log(10.0) << " dB (" << err/nbs << ").\n");
	}
*/
	{ // Copy of the remaining data
		short* buffer = new short[af_frame*af_channel];
		afReadFrames(infile, AF_DEFAULT_TRACK, (void*)buffer, af_frame);
		afWriteFrames(outfile, AF_DEFAULT_TRACK, (void*)buffer, af_frame);
		
		LOG("--[main::send] Copy phase OK.\n");
	}

	afCloseFile(infile);
	afCloseFile(outfile);
	
	return 0;
}

